/*
 * BMPFile.cpp
 *
 *  Created on: 03-12-2010
 *      Author: marcin
 */
#include "BMPFile.h"


BMPFile* loadBMPFile(std::string filename)
	{
			// Open file.
			ifstream bmpfile (filename.c_str() , ios::in | ios::binary);
			if (! bmpfile.is_open())
			{
				cout<<"ERROR:: loadBMPFile - opening " << filename <<" fail!\n";
				return NULL;		// Error opening file
			}

			BMPFile *file = new BMPFile();

			bmpfile.read ((char*)&(file->header.magic),2);
			bmpfile.read ((char*)&(file->header.fileSize),sizeof(uint));
			bmpfile.read ((char*)&(file->header.reserved),sizeof(uint));
			bmpfile.read ((char*)&(file->header.pixMapOffset),sizeof(uint));
			bmpfile.read ((char*)&(file->info.headerSize),sizeof(uint));
			bmpfile.read ((char*)&(file->info.width),sizeof(int));
			bmpfile.read ((char*)&(file->info.height),sizeof(int));
			bmpfile.read ((char*)&(file->info.nPlanes),2);
			bmpfile.read ((char*)&(file->info.bitCount),2);
			bmpfile.read ((char*)&(file->info.compression),sizeof(uint));
			bmpfile.read ((char*)&(file->info.pixMapSize),sizeof(uint));
			bmpfile.read ((char*)&(file->info.hRes),sizeof(int));
			bmpfile.read ((char*)&(file->info.vRes),sizeof(int));
			bmpfile.read ((char*)&(file->info.nColors),sizeof(uint));
			bmpfile.read ((char*)&(file->info.nImpColors),sizeof(uint));


			cout<<">>LOADING BMP FILE\n";
			cout<<"FILENAME   :: " << filename << '\n';
			cout<<"FILESIZE   :: " << file->header.fileSize << '\n';
			cout<<"MAPOFFSET  :: "<< file->header.pixMapOffset<< '\n';
			cout<<"HEADERSIZE :: " << file->info.headerSize << '\n';
			cout<<"WITDH      :: " << file->info.width << '\n';
			cout<<"HEIGHT     :: "<< file->info.height << '\n';
			cout<<"PLANES     :: " << file->info.nPlanes << '\n';
			cout<<"BPP        :: "<< file->info.bitCount << '\n';
			cout<<"COMPRESSION:: "<< file->info.compression <<'\n';
			cout<<"PIXMAPSIZE :: "<< 	file->info.pixMapSize <<"\n\n";


			// Assign some short variables:
			int BytesPerRow = file->info.width * file->info.bitCount / 8;
			BytesPerRow += (4-BytesPerRow%4) % 4;	// int alignment

			bmpfile.seekg (file->header.pixMapOffset,ios::beg);

			file->data= new char[BytesPerRow*file->info.height];

			bmpfile.read (file->data,BytesPerRow*file->info.height);
			char temp;
			for (int i=0;i<BytesPerRow*file->info.height;i+=3)
			 { // reverse all of the colors. (bgr -> rgb)
					temp = file->data[i];
					file->data[i] = file->data[i+2];
					file->data[i+2] = temp;
		     }
			bmpfile.close();

			return file;
}





/*
BMPFile* loadBMPFile(std::string fileName)
{
	const char *filename=fileName.c_str();
    FILE *file;
    unsigned long size;                 // size of the image in bytes.
    unsigned long i;                    // standard counter.
    unsigned short int planes;          // number of planes in image (must be 1)
    unsigned short int bpp;             // number of bits per pixel (must be 24)
    char temp;                          // temporary color storage for bgr-rgb conversion.

    // make sure the file is there.
    if ((file = fopen(filename, "rb"))==NULL)
    {
	printf("File Not Found : %s\n",filename);
	return 0;
    }

    BMPFile *image=new BMPFile();
    // seek through the bmp header, up to the width/height:
    fseek(file, 18, SEEK_CUR);

    // read the width
    if ((i = fread(&image->sizeX, 4, 1, file)) != 1) {
	printf("Error reading width from %s.\n", filename);
	return 0;
    }
    printf("Width of %s: %lu\n", filename, image->sizeX);

    // read the height
    if ((i = fread(&image->sizeY, 4, 1, file)) != 1) {
	printf("Error reading height from %s.\n", filename);
	return 0;
    }
    printf("Height of %s: %lu\n", filename, image->sizeY);

    // calculate the size (assuming 24 bits or 3 bytes per pixel).
    size = image->sizeX * image->sizeY * 3;

    // read the planes
    if ((fread(&planes, 2, 1, file)) != 1) {
	printf("Error reading planes from %s.\n", filename);
	return 0;
    }
    if (planes != 1) {
	printf("Planes from %s is not 1: %u\n", filename, planes);
	return 0;
    }

    // read the bpp
    if ((i = fread(&bpp, 2, 1, file)) != 1) {
	printf("Error reading bpp from %s.\n", filename);
	return 0;
    }
    if (bpp != 24) {
	printf("Bpp from %s is not 24: %u\n", filename, bpp);
	return 0;
    }

    // seek past the rest of the bitmap header.
    fseek(file, 24, SEEK_CUR);

    // read the data.
    image->data = (char *) new char[size];
    if (image->data == NULL) {
	printf("Error allocating memory for color-corrected image data");
	return 0;
    }

    if ((i = fread(image->data, size, 1, file)) != 1) {
	printf("Error reading image data from %s.\n", filename);
	return 0;
    }

    for (i=0;i<size;i+=3) { // reverse all of the colors. (bgr -> rgb)
	temp = image->data[i];
	image->data[i] = image->data[i+2];
	image->data[i+2] = temp;
    }

    // we're done.
    return image;
};
*/
