/*
 * BMPFile.h
 *
 *  Created on: 02-12-2010
 *      Author: marcin
 */

#ifndef BMPFILE_H_
#define BMPFILE_H_

#include <iostream>
#include <fstream>
#include <string>
#include <cstdio>

using namespace std;

typedef unsigned int uint;
typedef unsigned short ushort;
typedef unsigned char uchar;

struct BMPHeader
{
  uchar magic[2]; //should always be BM
  uint fileSize;	// file size in bits
  uint reserved;
  uint   pixMapOffset; //where pixel starts
};

struct BMPInfo {
  uint headerSize;
  int width;
  int height;
  ushort nPlanes;
  ushort bitCount;
  uint compression;
  uint pixMapSize;
  int hRes;
  int vRes;
  uint nColors;
  uint nImpColors;
};
/*
struct BMPFile {
    unsigned long sizeX;
    unsigned long sizeY;
    char *data;
};
*/

class BMPFile
{
public:
	BMPHeader header;
	BMPInfo info;
	char *data;

	BMPFile(){ data=NULL;
			   };
	~BMPFile(){ if (data!=NULL) delete(data); };
};


BMPFile* loadBMPFile(std::string fileName);
#endif /* BMPFILE_H_ */
