//some useful constants for snook3D Game

#ifndef CONSTANTS_H 
#define CONSTANTS_H

#include "GL/gl.h"
#include "Types.h"
#include <utility>


/* Physics default constants
 *
 * Don't use them directly!
 * Instead initialize local copies with these values, because we want to modify coefficients during runtime
 */

const real RESTITUTION = 0.995;
const real CUSHION_RESTITUTION = 0.7;


/* Real world dimensions in meters*/

const GLdouble TABLEWIDTH = 1.778;
const GLdouble TABLELENGTH = 3.569;
/*don't confuse following one with length, that is literally a height - means distance between ground and a playing*/
const GLdouble TABLEHEIGHT = 0.860;
const GLdouble BALLRADIUS = 0.02625;
const GLdouble DRADIUS = 0.292;
const GLdouble POCKETSIZE = 0.05;


const real CUSHIONSIZE = 0.2;
const real CUSHIONHEIGHT = BALLRADIUS*1.4;

/*following dimensions are relative to the center of the table*/
const GLdouble BAULK = -TABLELENGTH/2.0+0.737;
const std::pair<GLdouble,GLdouble> BLACKSPOT = std::pair<GLdouble,GLdouble>(0.0,TABLELENGTH/2-0.324);
const std::pair<GLdouble,GLdouble> BLUESPOT = std::pair<GLdouble,GLdouble>(0.0,0.0);
const std::pair<GLdouble,GLdouble> PINKSPOT = std::pair<GLdouble,GLdouble>(0.0,TABLELENGTH/4.0);
const std::pair<GLdouble,GLdouble> BROWNSPOT = std::pair<GLdouble,GLdouble>(0.0,BAULK);
const std::pair<GLdouble,GLdouble> YELLOWSPOT = std::pair<GLdouble,GLdouble>(-DRADIUS,BAULK);
const std::pair<GLdouble,GLdouble> GREENSPOT = std::pair<GLdouble,GLdouble>(DRADIUS,BAULK);


const GLdouble SCENEWIDTH = 10;
const GLdouble SCENELENGTH = 10;
const GLdouble SCENEHEIGHT = 10;

enum Color { WHITE=0, RED, YELLOW, GREEN, BROWN, BLUE, PINK, BLACK };

const GLfloat mat[8][3] = {{1.0f,1.0f,0.95f},{1.0f,0.0f,0.0f}, {0.95f,0.8f,0.0f},{0.0f,0.39f,0.0f},{0.55f,0.27f,0.008f},{0.0f,0.0f,0.8f},{0.98f,0.62f,0.66f},{0.1f,0.1f,0.1f}};

#endif
