/*
 * Timer.h
 *
 *  Created on: 24-11-2010
 *      Author: marcin
 */

#ifndef TIMER_H_
#define TIMER_H_

#ifdef WINDOWS   // Windows
#include <windows.h>
#else          // Unix
#include <sys/time.h>
#endif


class Timer
{
private:
    double startTimeInMicroSec;                 // starting time in micro-second
    double endTimeInMicroSec;                   // ending time in micro-second
    bool   ticking;                             // stop flag
#ifdef WINDOWS
    LARGE_INTEGER frequency;                    // ticks per second
    LARGE_INTEGER startCount;                   //
    LARGE_INTEGER endCount;                     //
#else
    timeval startCount;                         //
    timeval endCount;                           //
#endif



public:
    Timer();
    ~Timer();

    void   start();                             // start timer
    void stop();                              // stop the timer, and return time in mirco-second
    double getElapsedTimeInMilliSec();          // get elapsed time in milli-second
    double getElapsedTimeInMicroSec();          // get elapsed time in micro-second
    double getTimerSnapshot();
};

#endif /* TIMER_H_ */
