/*
 * Camera.h
 *
 *  Created on: 2010-11-21
 *      Author: krejziwan
 */

#ifndef CAMERA_H_
#define CAMERA_H_

#include "../Common/Types.h"
#include "../Common/Vector.h"
#include "../Common/Constants.h"

class Camera {
private:
	Vector eye;
	Vector u,v,n;
	real viewAngle, aspect, nearDist, farDist; // view volume shape
	void setModelViewMatrix(); // tell OpenGL where the camera is

public:
	Camera();
	void set(Vector eye, Vector look, Vector up); // like gluLookAt()
	void roll(real angle); // roll it
	void yaw(real angle); // yaw it
	void pitch(real angle); // pitch it
	void slide(real delU, real delV, real delN); // slide it
	void setShape(real vAng, real asp, real nearD, real farD);
	void rotate(real angle);

	Vector getN() const {
		return Vector(n.getX(),0.0,n.getZ()).unit();
	}
};

#endif /* CAMERA_H_ */
