/*
 * GameLogic.h
 *
 *  Created on: 03-12-2010
 *      Author: marcin
 */

#ifndef GAMELOGIC_H
#define GAMELOGIC_H

#include "GameState.h"
#include "../Physics/Physics.h"
#include "INotifiable.h"
#include "../Model/Ball.h"
#include "../Model/Stick.h"
#include "../Model/Table.h"
#include "../Model/Scene.h"
#include <vector>

using namespace std;

class GameLogic: public INotifiable
{
	private:
	 Physics *physics;
	 Scene   *scene;
	 GameState *state;
	 vector<Ball *> balle;


	 void makeNewTable();
	 void resetTable();

	public:
	 GameLogic(Physics *physicsNew=NULL,Scene *sceneNew=NULL)
		{
			 physics=physicsNew;
			 scene = sceneNew;
			 state=GameState::getInstance();
		}
		virtual ~GameLogic();

		void processNotification(ISubject *subject);

};

#endif
