/*
 * GameState.h
 *
 *  Created on: 28-11-2010
 *      Author: marcin

 */

#ifndef GAME_STATE_H
#define GAME_STATE_H


#include "IObservable.h"
#include <iostream>
#include <string>

using namespace std;

static string names[8]={"INIT","MAIN_MENU","NEW_GAME","HIT_BALL","ANIMATION","PAUSE","PAUSE","BALL_IN_HOLE"};

class GameState: public IObservable
{
public:
	enum State
	{
		BEFORE_GAME = -1,
		INIT = 0,
		MAIN_MENU = 1,
		NEW_GAME,
		HIT_BALL,
		ANIMATION,
		PAUSE_HIT,
		PAUSE_ANI,
		BALL_IN_HOLE
	};



	static GameState *getInstance()
	{
   	  if (instance == NULL)
			{
				instance = new GameState();
			}
	  return instance;
	}


	void setCurrentState(State state)
	{
		if (this->currentState!=state)
		{
			this->currentState = state;
			std::cout<<"STATE:: "<<names[currentState]<<'\n';
			this->notifySubscribers();
		}

	}

	State getCurrentState ()
	{
		return this->currentState;
	}



private:
	static GameState *instance;
	State currentState;
	GameState()
    {
		currentState = BEFORE_GAME ;

    };

	GameState(const GameState&);             // intentionally undefined

};

#endif
