#include "GlutEngine.h"

Engine *GlutEngine::engine=NULL;


void GlutEngine::registerEngine(Engine *newEngine)
{
	engine=newEngine;
}

void GlutEngine::setWindowName(std::string name)
{
	glutWindowName=name;
}

void GlutEngine::display()
{
	engine->display();
	glutSwapBuffers();
}

void GlutEngine::idle()
{
	engine->idle();
	glutPostRedisplay();
}

void GlutEngine::resize(int x, int y)
{
	engine->resize(x,y);
}

void GlutEngine::keyboard(unsigned char key, int x, int y)
{
	engine->handleKeyboardEvent(key,x,y);
	glutPostRedisplay();
}

void GlutEngine::mouse(int button,int state, int x, int y)
{
	engine->handleMouseEvent(button,state,x,y);
	glutPostRedisplay();
}

void GlutEngine::startEngine(int argc, char **argv)
{
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_ALPHA | GLUT_DEPTH);

	glutInitWindowPosition(Engine::WindowSuggestions::POSX,Engine::WindowSuggestions::POSY);
	glutCreateWindow(Engine::WindowSuggestions::windowName);
	glutDisplayFunc(display);
	glutIdleFunc(idle);
	glutReshapeFunc(resize);
	glutKeyboardFunc(keyboard);
	glutMouseFunc(mouse);
	glutReshapeWindow(Engine::WindowSuggestions::WIDTH,Engine::WindowSuggestions::HEIGHT);

	engine->init();
	engine->run();


	glutMainLoop();
}


