/*
 * GraphicDefinitions.h
 *
 *  Created on: 25-11-2010
 *      Author: marcin
 */

#ifndef GRAPHICDEFINITIONS_H_
#define GRAPHICDEFINITIONS_H_

#include "../Common/Constants.h"

#include <GL/gl.h>
#include <GL/glut.h>

enum Graphic
{
	SNOOK3D_BALL = 1,
	SNOOK3D_BALL_SHADOW,
	SNOOK3D_TABLE,
	SNOOK3D_TABLE_FRAME,
	SNOOK3D_FLOOR,
	SNOOK3D_WALL
};

inline void loadGraphicDefinitions()
{
		glNewList (SNOOK3D_BALL, GL_COMPILE);
			glutSolidSphere(BALLRADIUS,20,20);
		glEndList ();

		glNewList (SNOOK3D_BALL_SHADOW, GL_COMPILE);
			glDisable(GL_LIGHTING);
			glColor3f(0.05,0.05,0.05);
			glutSolidSphere(BALLRADIUS,20,20);
		glEndList ();



		glNewList(SNOOK3D_TABLE_FRAME,GL_COMPILE);
			glBegin(GL_QUADS);
				glNormal3f(0.0,1.0,0.0);
				glTexCoord2f(0.0f, 0.0f); glVertex3f(0.0f, CUSHIONHEIGHT,  TABLELENGTH/2);
				glTexCoord2f(1.0f, 0.0f); glVertex3f(TABLEWIDTH/2, CUSHIONHEIGHT,  TABLELENGTH/2);
				glTexCoord2f(1.0f, 1.0f); glVertex3f(TABLEWIDTH/2, CUSHIONHEIGHT, TABLELENGTH/2+CUSHIONSIZE);
				glTexCoord2f(0.0f, 1.0f); glVertex3f(0.0f, CUSHIONHEIGHT,  TABLELENGTH/2+CUSHIONSIZE);

				glNormal3f(0.0,1.0,0.0);
				glTexCoord2f(0.0f, 0.0f); glVertex3f(TABLEWIDTH/2, CUSHIONHEIGHT,  0.0);
				glTexCoord2f(1.0f, 0.0f); glVertex3f(TABLEWIDTH/2, CUSHIONHEIGHT,  TABLELENGTH/2+CUSHIONSIZE);
				glTexCoord2f(1.0f, 1.0f); glVertex3f(TABLEWIDTH/2+CUSHIONSIZE, CUSHIONHEIGHT, TABLELENGTH/2+CUSHIONSIZE);
				glTexCoord2f(0.0f, 1.0f); glVertex3f(TABLEWIDTH/2+CUSHIONSIZE, CUSHIONHEIGHT,  0);

				glNormal3f(1.0,0.0,0.0);
				glTexCoord2f(0.0f, 0.0f);glVertex3f(TABLEWIDTH/2+CUSHIONSIZE, -0.3, 0.0);
				glTexCoord2f(1.0f, 0.0f);glVertex3f(TABLEWIDTH/2+CUSHIONSIZE, CUSHIONHEIGHT,  0.0);
				glTexCoord2f(1.0f, 1.0f);glVertex3f(TABLEWIDTH/2+CUSHIONSIZE, CUSHIONHEIGHT, TABLELENGTH/2+CUSHIONSIZE);
				glTexCoord2f(0.0f, 1.0f);glVertex3f(TABLEWIDTH/2+CUSHIONSIZE, -0.3,  TABLELENGTH/2+CUSHIONSIZE);

				glNormal3f(0.0,0.0,1.0);
				glVertex3f(0.0f, -0.3, TABLELENGTH/2+CUSHIONSIZE);
				glVertex3f(0.0f, CUSHIONHEIGHT,  TABLELENGTH/2+CUSHIONSIZE);
				glVertex3f(TABLEWIDTH/2+CUSHIONSIZE, CUSHIONHEIGHT, TABLELENGTH/2+CUSHIONSIZE);
				glVertex3f(TABLEWIDTH/2+CUSHIONSIZE, -0.3f,  TABLELENGTH/2+CUSHIONSIZE);
			glEnd();

			glEndList();

			glNewList(SNOOK3D_TABLE,GL_COMPILE);

			glEnable(GL_LIGHTING);
					glBegin(GL_QUADS);
						//surface



						glNormal3f(0.0,1.0,0.0);
						glTexCoord2f(0.0f, 0.0f);
						glVertex3f(0.0f, 0.0f, 0.0f);
						glTexCoord2f(5.0f, 0.0f);
						glVertex3f(0.0f, 0.0f,  TABLELENGTH/2);
						glTexCoord2f(5.0f, 5.0f);
						glVertex3f(TABLEWIDTH/2, .0f, TABLELENGTH/2);
					glTexCoord2f(0.0f, 5.0f);
						glVertex3f(TABLEWIDTH/2, 0.0f,  0.0f);

						//cushions
						glNormal3f(-1.0,0.0,0.0);
						glVertex3f(TABLEWIDTH/2, 0.0, 0.0);
						glVertex3f(TABLEWIDTH/2, CUSHIONHEIGHT,  0.0);
						glVertex3f(TABLEWIDTH/2, CUSHIONHEIGHT, TABLELENGTH/2);
						glVertex3f(TABLEWIDTH/2, 0.0,  TABLELENGTH/2);

						glNormal3f(0.0,0.0,-1.0);
						glVertex3f(0.0, 0.0, TABLELENGTH/2);
						glVertex3f(0.0, CUSHIONHEIGHT, TABLELENGTH/2);
						glVertex3f(TABLEWIDTH/2, CUSHIONHEIGHT, TABLELENGTH/2);
						glVertex3f(TABLEWIDTH/2, 0.0,  TABLELENGTH/2);

						glEnd();
						glDisable(GL_LIGHTING);

						glColor3f(1,1,1);
						glEndList();

						glNewList(SNOOK3D_FLOOR,GL_COMPILE);

						glBegin(GL_QUADS);
						glNormal3f(0.0,1.0,0.0);
						glTexCoord2f(0.0f, 0.0f); glVertex3f(-3.0f, 0.0f, -3.0f);
						glTexCoord2f(0.0f, 3.0f); glVertex3f(-3.0f, 0.0f,  3.0);
						glTexCoord2f(3.0f, 3.0f); glVertex3f(3.0, .0f, 3.0);
						glTexCoord2f(3.0f, 0.0f); glVertex3f(3.0, 0.0f, -3.0f);

						glEnd();
						glEndList();



						glNewList(SNOOK3D_WALL,GL_COMPILE);

						glBegin(GL_QUADS);

						glNormal3f(0.0,1.0,0.0);
						glTexCoord2f(0.0f, 0.0f); glVertex3f(-5.0f, 0.0f, -5.0f);
						glTexCoord2f(0.0f, 1.0f); glVertex3f(-5.0f, 5.0f,  -5.0);
						glTexCoord2f(1.0f, 1.0f); glVertex3f(5.0, 5.0f, -5.0);
						glTexCoord2f(1.0f, 0.0f); glVertex3f(5.0, 0.0f, -5.0f);

						glEnd();
						glEndList();


}




#endif /* GRAPHICDEFINITIONS_H_ */
