/*
 * IObservable.h
 *
 *  Created on: 28-11-2010
 *      Author: marcin
 */

#ifndef IOBSERVABLE_H_
#define IOBSERVABLE_H_

#include "ISubject.h"
#include "INotifiable.h"
#include <vector>
#include <algorithm>

class IObservable: public ISubject
{
	public:
	 ~IObservable(){};

	 Type getType(){ return ISubject::State; };
		void notifySubscribers()
		{
			  for (std::vector<INotifiable *>::iterator it=observers.begin(); it<observers.end(); it++)
			  {
				  (*it)->processNotification(this);
			  }

		};

	 void subscribe(INotifiable *observer)
	 	{
	 		observers.push_back(observer);

	 	};

	 void unSubscribe(INotifiable *observer)
	 	{

	 		std::vector<INotifiable *>::iterator  it = find (observers.begin(), observers.end(), observer);
	 		observers.erase(it);

	 	};

	private:
	 std::vector<INotifiable *> observers;
};

#endif /* IOBSERVABLE_H_ */
