/*
 * TextureManager.h
 *
 *  Created on: 28-11-2010
 *      Author: Marcin Ciechowicz
 */

#ifndef TEXTUREMANAGER_H_
#define TEXTUREMANAGER_H_

#include "TextureDefinitions.h"
#include "../Common/BMPFile.h"
#include "GL/gl.h"
#include <vector>


class TextureManager
{
public:
	typedef enum {
		NoFilter	= 0,
		Bilinear	= 1,
		Trilinear	= 2
		// add new ones at the end
	} TexFilterType;
	static TextureManager  *getInstance()
	{
   	  if (instance  == NULL)
			{
				instance = new TextureManager ();
			}
	  return instance;
	}



private:
	GLuint *texture;

	static TextureManager *instance;
	TextureManager(){};
	TextureManager(const 	TextureManager&);             // intentionally undefined
	std::vector<BMPFile*> BMPTextures;
	TexFilterType filterType;
public:
	void loadTextures();
	GLuint giveMeTexture(int textureName);
//	static void loadTextures(int *glNames, std::string *fileNames){};
//	static void setParams();
};

#endif /* TEXTUREMANAGER_H_ */
