#include "Ball.h"
#include "../Engine/GraphicDefinitions.h"
#include <iostream>
#include <GL/gl.h>
#include <GL/glut.h>


Ball::Ball(Color ballColor, Vector ballPosition):color(ballColor)
{
	radius=BALLRADIUS;
	position=ballPosition;
}

inline void  Ball::draw()
{
	if (visible)
	{
		glPushMatrix();
		glEnable(GL_LIGHTING);
		//		 glEnable(GL_LIGHT0);
		GLfloat mat_ambient[] = { 0.02, 0.02f, 0.02f, 1.0f};// Colour of the ball according to elasticity
		//GLfloat mat_diffuse[] = { 1.0f, 0.01f, 0.01f, 1.0f};
		GLfloat mat_specular[] = { 1.0f, 1.0f, 1.0f, 1.0f};
		GLfloat mat_shininess[] = { 128.0f };
		glMaterialfv(GL_FRONT, GL_AMBIENT, mat_ambient);
//		glMaterialfv(GL_FRONT, GL_DIFFUSE, mat[color]);
		glMaterialfv(GL_FRONT, GL_SPECULAR, mat_specular);
		glMaterialfv(GL_FRONT, GL_SHININESS, mat_shininess);

		glTranslated(position.getX(),position.getY(),position.getZ());
		glColor3fv(mat[color]);

		glCallList(SNOOK3D_BALL);
		glPopMatrix();
	}
}

void Ball::drawShadow(Vector &lightPosition)
{
	float d, c;
	float mat[16];

	d = (-1)*lightPosition.getY();
	c = (position.getY() - BALLRADIUS)*(-1) - d;

	// Create the matrix. OpenGL uses column by column
	// ordering

	mat[0]  = c;
	mat[4]  = (-1)*lightPosition.getX();
	mat[8]  = 0;
	mat[12] = -lightPosition.getX()*c-lightPosition.getX()*d;

	mat[1]  = 0;
	mat[5]  = lightPosition.getY()*(-1) + c;
	mat[9]  = 0;
	mat[13] = -lightPosition.getY()*c-lightPosition.getY()*d;

	mat[2]  = 0;
	mat[6]  = (-1)*lightPosition.getZ();
	mat[10] = c;
	mat[14] = -lightPosition.getZ()*c-lightPosition.getZ()*d;

	mat[3]  = 0;
	mat[7]  = -1;
	mat[11] = 0;
	mat[15] = -d;
	//			  glPushMatrix();
	glPushMatrix();
	glTranslated(position.getX(),position.getY()+0.001,position.getZ());
	glMultMatrixf(mat);

	glCallList(SNOOK3D_BALL_SHADOW);

	glPopMatrix();
}




