#include "Scene.h"

void Scene::add(GameObject *element)
{
	elements.push_back(element);
}

void Scene::draw() 
{
	for_each(elements.begin(), elements.end(), mem_fun(&GameObject::draw));

	glEnable(GL_TEXTURE_2D);

	glBindTexture(GL_TEXTURE_2D, textMan->giveMeTexture(FLOOR));

	glPushMatrix();
	glTranslated(0.0,-TABLEHEIGHT,0.0);
	glScaled(2.0,1.0,2.0);
		glCallList(SNOOK3D_FLOOR);
	glPopMatrix();

	glBindTexture(GL_TEXTURE_2D, textMan->giveMeTexture(WALL));

	glPushMatrix();
	glTranslated(0.0,-TABLEHEIGHT,0.0);
		glCallList(SNOOK3D_WALL);
	glRotated(90,0.0,1.0,0.0);
		glCallList(SNOOK3D_WALL);
	glRotated(90,0.0,1.0,0.0);
		glCallList(SNOOK3D_WALL);
	glRotated(90,0.0,1.0,0.0);
		glCallList(SNOOK3D_WALL);
	glPopMatrix();

	glDisable(GL_TEXTURE_2D);
}


void Scene::drawShadows(Vector &lightPosition)
{
	for_each(elements.begin(), elements.end(),  bind2nd(mem_fun(&GameObject::drawShadow),lightPosition));
//	for_each(elements.begin(), elements.end(),  funkcja(lightPosition));
}

