#include "Stick.h"
#include <iostream>


bool Stick::isVisible()
{
	return false;
}
void Stick::draw()
{
	std::cout<<" I'AM THE STICK" << std::endl;
	drawStick(0.01,0.005,1.0,10);
}


void Stick::drawStick(real r1, real r2 ,real length, int facets) {
	real angleInc = 360/(real)facets;
	real cs = cos(3.14159265 /180 * angleInc);
	real sn = sin(3.14159265 /180 * angleInc);
	real tmpx, tmpz;
	real x = 1.0,z = 0.0;


	glEnable(GL_TEXTURE_2D);
	glBindTexture(GL_TEXTURE_2D, textMan->giveMeTexture(STICK));

	glPushMatrix();

	glBegin(GL_QUADS);

	for(int i = 0;i<facets;i++) {
		tmpx = cs*x-sn*z;
		tmpz = sn*x+cs*z;
		glNormal3f(0.0,1.0,0.0);
		glTexCoord2f(i/(real)facets, 0.0f); glVertex3f(x*r1, 0.0, z*r1);
		glTexCoord2f((i+1)/(real)facets, 0.0f); glVertex3f(tmpx*r1, 0.0,  tmpz*r1);
		glTexCoord2f((i+1)/(real)facets, 1.0f); glVertex3f(tmpx*r2, length, tmpz*r2);
		glTexCoord2f(i/(real)facets, 1.0f); glVertex3f(x*r2, length, z*r2);
		x = tmpx;
		z = tmpz;
	}
	glEnd();
	glPopMatrix();
	glDisable(GL_TEXTURE_2D);
}
