/*
 * ContactGenerator.cpp
 *
 *  Created on: 2010-11-20
 *      Author: krejziwan
 */

#include "ContactGenerator.h"

std::vector<Contact> ContactGenerator::generateContacts(std::vector<RigidBody *>& bodies) {
	std::vector<RigidBody *>::iterator it = bodies.begin();
	std::vector<Contact> ret;
	Vector pos, relPos;
	real distance;
//	std::cout << "wlazlem tu2 ";

	for(;it!=bodies.end();++it) {
		//if ball is not awake then its definitely not the initiator of the collision, so we can skip this step
		if(!((*it)->isAwake()))
			continue;
		//get the position of the ball
		pos = (*it)->getPosition();
		//check if it hits the bounce
		//TODO somewhere here should be a code which recognizes if its not actually a cushion but the pocket
		//TODO I ve just realized that x positive is at left and negative at right
		if(pos.getX()<-TABLEWIDTH/2.0+BALLRADIUS) {
//			std::cout << "lewa";
			ret.push_back(Contact(Vector(1.0,0.0,0.0),BALLRADIUS-(pos.getX()+TABLEWIDTH/2.0),*it,NULL));
		}
		else if (pos.getX()>TABLEWIDTH/2.0-BALLRADIUS) {
//			std::cout << "prawa";
			ret.push_back(Contact(Vector(-1.0,0.0,0.0), BALLRADIUS-(TABLEWIDTH/2.0-pos.getX()), *it,NULL));
		}
		else if (pos.getZ()<-TABLELENGTH/2.0+BALLRADIUS) {
//			std::cout << "dol";
			ret.push_back(Contact(Vector(0.0,0.0,1.0), BALLRADIUS-(pos.getZ()+TABLELENGTH/2.0), *it,NULL));
		}
		else if (pos.getZ()>TABLELENGTH/2.0-BALLRADIUS) {
//			std::cout << "gora";
			ret.push_back(Contact(Vector(0.0,0.0,-1.0), BALLRADIUS-(TABLELENGTH/2.0-pos.getZ()), *it,NULL));
		}
		//right now is the worst and most time consuming part of algorithm. You have to check the ball collides with some other balls
		for (std::vector<RigidBody *>::iterator it2 = bodies.begin(); it2 !=bodies.end();++it2) {
			if(it==it2) continue;
			relPos = pos-((*it2)->getPosition());
			distance = relPos.magnitude();
			if(distance<2*BALLRADIUS) {
				//we have collision
				ret.push_back(Contact(relPos.unit(),2*BALLRADIUS-distance, *it, *it2));
			}
		}
	}
	return ret;
}

void ContactGenerator::findNeighbors(std::vector<RigidBody*>& bodies) {
	for_each(bodies.begin(),bodies.end(),std::bind2nd(mem_fun(&RigidBody::findNeighbors),bodies));
//	for(std::vector<RigidBody *>::iterator it = bodies.begin(); it!=bodies.end();++it) {
//		std::vector<RigidBody *> neighs;
//	}
}

