/*
 * World.cpp
 *
 *  Created on: 2010-11-12
 *      Author: krejziwan
 */

#include "Physics.h"

void Physics::integrate(real duration) {
	for_each(bodies.begin(),bodies.end(),bind2nd(mem_fun(&RigidBody::integrate),duration));
}

void Physics::startFrame() {
//	for_each(bodies.begin(),bodies.end(),mem_fun(&RigidBody::reset));

}

void Physics::physicsUpdate(real durationInMicroSec) {

	real duration = (real) 0.000001*durationInMicroSec;
//	std::cout << duration << ' ';

	//update forces
	//update positions
	integrate(duration);
	findBallsInPocket();
	//find contacts
	generator->findNeighbors(bodies);
	contacts = generator->generateContacts(bodies);
	//resolve contacts appropiately
	resolver->resolveContacts(contacts);
//	std::cout << bodies.size();
	//sleep(1);
	if(isAnimationFinished()) {
//		std::cout << "KONIEC ANIMACJI\n";
		state->setCurrentState(GameState::HIT_BALL);
	}

}

RigidBody * Physics::getCueBall() {
	return NULL;
}

void Physics::hitCueBall(const Vector& normal, real _power, const Vector& stick) {
	white->setAwake(true);
	white->updateVelocity(-normal*power*_power);
//	cout << "hitted " << white->getPosition() << white->getVelocity();
	cout.flush();
}

void Physics::add(RigidBody * b) {
	bodies.push_back(b);
}

void Physics::findBallsInPocket() {
	Vector pos;
	for(std::vector<RigidBody *>::iterator it = bodies.begin();it!= bodies.end();++it) {
		pos = (*it)->getPosition();
		if(isInPocket(pos)) {
			std::cout << "IS IN POCKET: " << (*it)->getNumber() << '\n';
		}
	}
}

void Physics::processNotification(ISubject * subject) {

	if (subject->getType()==ISubject::State)
	{
		GameState *st=(GameState *) subject;
		if (st->getCurrentState() == GameState::MAIN_MENU) {
			reset();
		}
		else if (st->getCurrentState() == GameState::NEW_GAME) {

		}
	}

}

