/*
 * RigidBody.cpp
 *
 *  Created on: 2010-11-20
 *      Author: krejziwan
 */

#include "RigidBody.h"

#define EPS 0.001

void RigidBody::integrate(real duration) {
	if(!awake)
		return;
	motion = calculateEnergy();
//	std::cout << motion << '\n';
	if(motion<EPS) {
		setAwake(false);
		return;
	}
	updatePosition(velocity*duration);
	Vector v = calculateVelChange(duration);
	updateVelocity(v);
}

Vector RigidBody::calculateVelChange(real duration) const {
//	std::cout << duration << '\n';
//	return Vector(0.0,0.0,0.0);-velocity*duration;
	return -velocity.unit()*(0.1*duration);
	//pomniejszenie predkosci o jej pewien ulamek nie wyglada realistycznie
	//m*g*f=0.05*10*f=.5f[m/s^2] co oznacza ze predkosc zmienia sie o ok. 0.45 na 1s
//	return velocity*0.45*duration;
}
