/*
 * EventHandler.cpp
 *
 *  Created on: 2010-11-21
 *      Author: krejziwan
 */

#include "EventHandler.h"


EventHandler::~EventHandler() {
	// TODO Auto-generated destructor stub
}

EventHandler::EventHandler(Physics *phys, Camera *camera,GameState *statek)
{
	cam=camera;
	physics=phys;
	state=statek;
	slidespeed=0.05;
	rotatespeed=1.0;


				activeKeyBindings=NULL;

}

void EventHandler::handleKeyboardEvent(unsigned char key, int x, int y)
{
	if (activeKeyBindings!=NULL)
	{
	std::map<unsigned char, func>::iterator it = activeKeyBindings->find(key);
	if(it!=activeKeyBindings->end())
		(this->*(it->second))();
	}
	else
		std::cout<<"ALERT"<< '\n';
}

void EventHandler::handleMouseEvent(int button, int state, int x, int y)
{

}


void EventHandler::processNotification(ISubject *subject)
{
	if (subject->getType()==ISubject::State)
	{
		GameState *st=(GameState *) subject;

		if (st->getCurrentState() == GameState::INIT)
		{
			std::map<unsigned char, func>* (EventHandler::*p[])()=
			{
							  &EventHandler::mainMenuBindings,
							  &EventHandler::gameBindings,
							  &EventHandler::pauseBindings,
							  &EventHandler::animationBindings
			};
			string keyBindingName[] = {"main","game","pause","animation"};

			for (int i=0; i<KEYBINDINGS; i++)
			{
				keyBindings.insert
				(
				std::pair<std::string, std::map<unsigned char, func>* >
								 (keyBindingName[i],(this->*p[i])())
				);
			}


		}
		else if (st->getCurrentState() == GameState::MAIN_MENU)
		{
			std::map<std::string, std::map<unsigned char, func>*>::iterator it = keyBindings.find("main");
				if(it!=keyBindings.end())
				{
					activeKeyBindings = it->second;

				}
		}
		else if (st->getCurrentState() == GameState::HIT_BALL)
				{
			std::map<std::string, std::map<unsigned char, func>*>::iterator it = keyBindings.find("game");
						if(it!=keyBindings.end())
								activeKeyBindings = it->second;

				}

		else if (st->getCurrentState() == GameState::PAUSE_ANI || st->getCurrentState() == GameState::PAUSE_HIT )
		{
			std::map<std::string, std::map<unsigned char, func>*>::iterator it = keyBindings.find("pause");
									if(it!=keyBindings.end())
											activeKeyBindings = it->second;

		}

		else if (st->getCurrentState() == GameState::ANIMATION )
			{
				std::map<std::string, std::map<unsigned char, func>*>::iterator it = keyBindings.find("animation");
										if(it!=keyBindings.end())
												activeKeyBindings = it->second;

			}
	}


}
